/*
 * "The Road goes ever on and on, down from the door where it began."
 */

#include "EXTERN.h"
#include "perl.h"

static void xs_init _((void));
static PerlInterpreter *my_perl;

int
main(argc, argv, env)
int argc;
char **argv;
char **env;
{
    int exitstatus;

#ifdef VMS
    getredirection(&argc,&argv);
#endif

    if (!do_undump) {
	my_perl = perl_alloc();
	if (!my_perl)
	    exit(1);
	perl_construct( my_perl );
    }

    exitstatus = perl_parse( my_perl, xs_init, argc, argv, env );
    if (exitstatus)
	exit( exitstatus );

    exitstatus = perl_run( my_perl );

    perl_destruct( my_perl );
    perl_free( my_perl );

    exit( exitstatus );
}

/* Register any extra external extensions */

static void
xs_init()
{
    /* Do not delete this line--writemain depends on it */
    char *file = __FILE__;
    {   extern void boot_DynaLoader _((CV* cv));
        newXS("DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
    }
    {   extern void boot_Fcntl _((CV* cv));
        newXS("Fcntl::bootstrap", boot_Fcntl, file);
    }
    {   extern void boot_NDBM_File _((CV* cv));
        newXS("NDBM_File::bootstrap", boot_NDBM_File, file);
    }
    {   extern void boot_ODBM_File _((CV* cv));
        newXS("ODBM_File::bootstrap", boot_ODBM_File, file);
    }
    {   extern void boot_POSIX _((CV* cv));
        newXS("POSIX::bootstrap", boot_POSIX, file);
    }
    {   extern void boot_SDBM_File _((CV* cv));
        newXS("SDBM_File::bootstrap", boot_SDBM_File, file);
    }
    {   extern void boot_Socket _((CV* cv));
        newXS("Socket::bootstrap", boot_Socket, file);
    }
}
